/*
**********************************************************************************************************************
*											        eGon
*						           the Embedded GO-ON Bootloader System
*									       eGON axf sub-system
*
*						  Copyright(C), 2006-2010, SoftWinners Microelectronic Co., Ltd.
*                                           All Rights Reserved
*
* File    : elf_parser
*
* By      : Jerry
*
* Version : V2.00
*
* Date	  :
*
* Descript:
**********************************************************************************************************************
*/
#include "elf_parser.h"
#include "elf_private.h"
#include "mod_private.h"
#include "include.h"
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
static __s32 _is_spec_section(void *elf_img, struct __ELF32SHEAD *elf32shead, __u8 *section_name_section_base, eGon2_mod_t **priv_save)
//ȷǷΪĶΣȷͣһӦ
{
	eGon2_mod_t	*tmp_header = NULL;
	__u8 * section_name = NULL;
	*priv_save = NULL;

    //nameԱָsectionֵ֡sectionͷַsection
	section_name = (__u32)elf_img + section_name_section_base + elf32shead->name;

	//ҵEGON2_MAGIC
	if(!strcmp((void *)section_name, eGon2_HEADER_COMM_MAGIC))
	{
        //offsetļеƫ
        //ˣtmp_headerָ˸öε׵ַ
		tmp_header = (eGon2_mod_t *) ((__u32)elf_img + (__u32)(elf32shead->offset));
		//ȻprivָǸö(Զεľ)ELFļѾû̫ϵ
        *priv_save = tmp_header;
        if(tmp_header->magic[7] == 'p')
        {
            return eGON2_SUB_TYPE_APP;
        }
        else
        {
            return eGON2_SUB_TYPE_DRV;
        }
    }

	return 0;
}
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
static __s32 _load_section(__u32 elf_type, void *elf_img, struct __ELF32SHEAD *elf32shead)
{

	__u32 copyclear = 0;

	//Σж϶ε
	//SHT_PROGBITS: section汻˵һЩϢĸʽȡڳ
	//SHT_NOBITS  : ͵sectionļвռռ䣬SHT_PROGBITSܸsectionֽڣ
	//              sh_offsetԱ˸ϵļƫ
	switch (elf32shead->type)
	{
		//ΣRO,RW
		case EELF_SHT_PROGBITS:
		{
		    //SHF_ALLOC : sectionڽִйռڴ
			if(elf32shead->flags & EELF_SHF_ALLOC)
			{
			    //SHF_EXECINSTR : section˿ִеĻָ
			    //SHF_WRITE     : sectionڽִйпɱд
            	if((elf32shead->flags & EELF_SHF_EXECINSTR) || (elf32shead->flags & EELF_SHF_WRITE))
        		{
            		copyclear = 1;
        		}
			}
			break;
		}
		//NOBITS
        case EELF_SHT_NOBITS:
		{
		    //SHF_ALLOC : sectionڽִйռڴ
        	if(elf32shead->flags & EELF_SHF_ALLOC)
			{
            	copyclear = 2;
        	}
			break;
		}
        default:
           return 0;
	}

	if(copyclear == 1)
	{
	    //Ӧַ
   		memcpy((void *)(elf32shead->addr),(void *)((__u32)elf_img + (__u32)(elf32shead->offset)), elf32shead->size);

		return 1;
	}
	else if(copyclear == 2)
	{
	    //ڴ
		memset((void *)(elf32shead->addr), 0, elf32shead->size);

		return 1;
    }

	return 0;
}
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
__s32 elf_loader(void * elf_img, __u32 *entry)
{
	__u32   i = 0;
	__u8	sepc_section_index = 0;	//εindex
	struct  __ELF32HEAD 	_elf32head;
	struct  __ELF32SHEAD 	_elf32shead;
	struct  __ELF32HEAD     *elf32head  = &_elf32head;
	struct  __ELF32SHEAD    *elf32shead = &_elf32shead;
	         eGon2_mod_t     *priv = NULL;
	__u32	section_name_section_offset = 0;	//sctionsection ļеλ
	__u32                    elf_type;

	elf32head = (struct __ELF32HEAD  *)elf_img;
	elf_type = 0;

    //check it, жǷΪЧelfļ
    //elfļͷ4̶ֽڣֱ0x7f, 'E', 'L', 'F',Ϊelfʽļ
	if(	(elf32head->ident[EI_MAG0] != ELFMAG0 ) ||
		(elf32head->ident[EI_MAG1] != ELFMAG1 ) ||
		(elf32head->ident[EI_MAG2] != ELFMAG2 ) ||
		(elf32head->ident[EI_MAG3] != ELFMAG3 ) )
	{
		*entry = 0;
        eGon2_printf("elf file header magic not match\n");

		return -1;
	}

	//ڵַ
	//entryelfṩĵһƵַ̡ļûιڵ㣬óԱͱΪ0
	if((__u32)(elf32head->entry) < 0x40000000)
	{
	    eGon2_printf("elf file entry address not correct\n");

	    return -1;
	}

	//section_name_section_offset
	//shoffsectionͷsection header tableelfļеƫ(ֽڼ)
	//shstrndxŸsectionַڵsectionͷ(section header table)
	//elfеsectionһÿǰչ̶ݽṹ
	//ˣelf32sheadָsectionַڵsectionͷĵַ
	elf32shead = ( struct __ELF32SHEAD *)((__u32)elf_img + elf32head->shoff + (sizeof(struct __ELF32SHEAD))*(elf32head->shstrndx));
	//offsetԱ˸sectionֽƫ(ļʼ)
	//section_name_section_offsetsectionַļеƫ
	section_name_section_offset = elf32shead->offset;

	//shnumԱڳͷڵĸ
	//forѭеĳͷ
	for(i = 0; i < elf32head->shnum; i++)
	{
		__s32 temp = 0;

        //elf32sheadָÿһsectionĵַ
		elf32shead = ( struct __ELF32SHEAD *)((__u32)elf_img + elf32head->shoff + (sizeof(struct __ELF32SHEAD)) * i);
		temp = _is_spec_section(elf_img, elf32shead, (__u8 *)section_name_section_offset, &priv);

		if(temp == eGON2_SUB_TYPE_APP || temp == eGON2_SUB_TYPE_DRV)
		{
			elf_type = temp;
			sepc_section_index = i;

			break;
		}
	}
	if(elf_type == 0)
	{
	    eGon2_printf("elf file is not a app or driver\n");

		return -1;
	}

	//fexֵ֧elfļ
	for(i = 0; i < elf32head->shnum; i++)
	{
	    //elf32sheadָÿһsectionĵַ
		elf32shead = ( struct __ELF32SHEAD *)((__u32)elf_img + elf32head->shoff + (sizeof(struct __ELF32SHEAD)) * i);

		//ֻҪǰҵض
		if(sepc_section_index != i)
		{
			//ͨĴ
			if(_load_section(elf_type, elf_img, elf32shead) < 0)
			{
				return -1;
			}
		}
	}

	//
	if(priv != NULL)
	{
		if(elf_type == eGON2_SUB_TYPE_DRV)
		{
			return eGon2_driver_reg(priv);
		}
		else if(elf_type == eGON2_SUB_TYPE_APP)
		{
			*entry = (__u32)priv->main;

			return 0;
		}
	}

    eGon2_printf("can't find elf file entry\n");

	return -1;
}

